procedure Disassemb;
type str=string[30];
  var S,I,y,OP,maxI  : integer;
      Reg  : txt2;
      HZ   : Adr;
      OZ   : str;
      ASCII1 : string[80];
      Adresse : array[0..1500] of integer;

function zeile(var PC1:integer;var ASCII:txt2):txt2;
  begin
    zeile:=HEX(Puffer[PC1])+' ';
    if Puffer[PC1] IN [32..125] then ASCII:=ASCII+chr(Puffer[PC1])
    else ASCII:=ASCII+' ';
    PC1:=succ(PC1);
  end;

procedure OneByte(var z:adr);
  begin
    z:=zeile(PC1,ASCII)+'       ';
  end;

procedure TwoByte(var z:adr);
  begin
    z:=zeile(PC1,ASCII)+zeile(PC1,ASCII)+'    ';
  end;

procedure ThreByte(var z:adr);
  begin
    z:=zeile(PC1,ASCII)+zeile(PC1,ASCII)+zeile(PC1,ASCII)+' ';
  end;

  function SFR8(len:integer):str;
    const SFR : array[128..255] of Adr =
              ('P0','SP','DPL','DPH','','','','','TCON','TMOD',
               'TL0','TL1','TH0','TH1','','','P1','','','','','','',
               'PCON','SCON','SBUF','','','','','','','P2','','','',
               '','','','','IE','','','','','','','','P3','','','',
               '','','','','IP','','','','','','','','','','','','',
               '','','','T2CON','','RCAP2L','RCAP2H','TL2','TH2','','',
               'PSW','','','','','','','','','','','','','','','',
               'ACC','','','','','','','','','','','','','','','',
               'B','','','','','','','','','','','','','','','');
    var buff : str;
    begin
      if Puffer[PC1-len]>127 then begin
        buff:=SFR[Puffer[PC1-len]];
        if buff<>'' then SFR8:='    ;('+buff+')' else SFR8:=''; end
      else SFR8:='';
    end;

  function SFR1(len:integer):str;
    const SFR : array[128..255] of Adr =
       ('P0.0','P0.1','P0.2','P0.3','P0.4','P0.5','P0.6','P0.7',
        'IT0','IE0','IT1','IE1','TR0','TF0','TR1','TF1',
        'P1.0','P1.1','P1.2','P1.3','P1.4','P1.5','P1.6','P1.7',
        'RI','TI','RB8','TB8','REN','SM2','SM1','SM0',
        'P2.0','P2.1','P2.2','P2.3','P2.4','P2.5','P2.6','P2.7',
        'EX0','ET0','EX1','ET1','ES','ET2','','EA',
        'P3.0','P3.1','P3.2','P3.3','P3.4','P3.5','P3.6','P3.7',
        'PX0','PT0','PX1','PT1','PS','PT2','','',
        '','','','','','','','',
        'CP/RL2','C/T2','TR2','EXEN2','TCLK','RCLK','EXF2','TF2',
        'P','','OV','RS0','RS1','F0','AC','CY',
        '','','','','','','','',
        'ACC.0','ACC.1','ACC.2','ACC.3','ACC.4','ACC.5','ACC.6','ACC.7',
        '','','','','','','','',
        'B.0','B.1','B.2','B.3','B.4','B.5','B.6','B.7',
        '','','','','','','','');

    var buff : str;
        vekt : integer;
    begin
      vekt:=Puffer[PC1-len];
      if vekt>127 then buff:=SFR[vekt]
      else buff:=HEX((vekt div 8)+32)+'.'+chr((vekt mod 8)+48);
      if buff<>'' then SFR1:='    ;('+buff+')' else SFR1:='';
    end;

  function Register(OPC:integer):txt2;
    const R : array[6..15] of txt2 =
              ('@R0','@R1','R0','R1','R2','R3','R4','R5','R6','R7');
    begin Register:='';
      if OPC=4 then Register:='#'+HEX(Puffer[PC1+1]) else
      if OPC<6 then
        Register:=HEX(Puffer[PC1+1])
      else Register:=R[OPC];
    end;

  function SprAdr(OPC:integer):txt2;
  begin
   SprAdr:=HEX2(((PC1+PC0) AND (-2048))+(OPC div 32)*256+Puffer[PC1-1]);
  end;

  function RelAdr:txt2;
  var buff : integer;
  begin
    buff:=Puffer[PC1-1];
    if (buff and 128)=0 then RelAdr:=HEX2(buff+PC1+PC0) else
    RelAdr:=HEX2(PC1+PC0-(256-buff));
  end;


procedure DisZeile;
begin
        ASCII:='';
        OP:=Puffer[PC1];
        Reg:=Register(OP and 15);
        write(HEX2(PC1+PC0),'    ');
        case OP of
         0: begin OneByte(HZ); OZ:='NOP'; end;
         2: begin ThreByte(HZ);
            OZ:='JMP   '+HEX2(Puffer[PC1-2]*256+Puffer[PC1-1]);
            end;
         3: begin Onebyte(HZ); OZ:='RR    A'; end;
         4: begin Onebyte(HZ); OZ:='INC   A'; end;
         5: begin Twobyte(HZ); OZ:='INC   '+Reg+SFR8(1); end;
        16: begin Threbyte(HZ);
            OZ:='JBC   '+Reg+','+RelAdr+SFR1(2) end;
        18: begin Threbyte(HZ);
            OZ:='CALL  '+HEX2(Puffer[PC1-2]*256+Puffer[PC1-1]);
            end;
        19: begin Onebyte(HZ); OZ:='RRC   A'; end;
        20: begin Onebyte(HZ); OZ:='DEC   A'; end;
        21: begin Twobyte(HZ); OZ:='DEC   '+Reg+SFR8(1); end;
        32: begin Threbyte(HZ);
            OZ:='JB    '+Reg+','+RelAdr+SFR1(2) end;
        34: begin Onebyte(HZ); OZ:='RET'; end;
        35: begin Onebyte(HZ); OZ:='RL    A'; end;
        36: begin Twobyte(HZ); OZ:='ADD   A,'+Reg; end;
        37: begin Twobyte(HZ); OZ:='ADD   A,'+Reg+SFR8(1); end;
        48: begin Threbyte(HZ);
            OZ:='JNB   '+Reg+','+RelAdr+SFR1(2) end;
        50: begin Onebyte(HZ); OZ:='RETI'; end;
        51: begin Onebyte(HZ); OZ:='RLC   A'; end;
        52: begin Twobyte(HZ); OZ:='ADDC  A,'+Reg; end;
        53: begin Twobyte(HZ); OZ:='ADDC  A,'+Reg+SFR8(1); end;
        64: begin Twobyte(HZ); OZ:='JC    '+RelAdr; end;
        66: begin Twobyte(HZ); OZ:='ORL   '+Reg+',A'+SFR8(1); end;
        67: begin Threbyte(HZ);
              OZ:='ORL   '+Reg+',#'+HEX(Puffer[PC1-1])+SFR8(2); end;
        68: begin Twobyte(HZ); OZ:='ORL   A,'+Reg; end;
        69: begin Twobyte(HZ); OZ:='ORL   A,'+Reg+SFR8(1); end;
        80: begin Twobyte(HZ); OZ:='JNC   '+RelAdr; end;
        82: begin Twobyte(HZ); OZ:='ANL   '+Reg+',A'+SFR8(1); end;
        83: begin Threbyte(HZ);
              OZ:='ANL   '+Reg+',#'+HEX(Puffer[PC1-1])+SFR8(2); end;
        84: begin Twobyte(HZ); OZ:='ANL   A,'+Reg; end;
        85: begin Twobyte(HZ); OZ:='ANL   A,'+Reg+SFR8(1); end;
        96: begin Twobyte(HZ); OZ:='JZ    '+RelAdr; end;
        98: begin Twobyte(HZ); OZ:='XRL   '+Reg+',A'+SFR8(1); end;
        99: begin Threbyte(HZ);
              OZ:='XRL   '+Reg+',#'+HEX(Puffer[PC1-1])+SFR8(2); end;
       100: begin Twobyte(HZ); OZ:='XRL   A,'+Reg; end;
       101: begin Twobyte(HZ); OZ:='XRL   A,'+Reg+SFR8(1); end;
       112: begin Twobyte(HZ); OZ:='JNZ   '+RelAdr; end;
       114: begin Twobyte(HZ); OZ:='ORL   C,'+Reg+SFR1(1); end;
       115: begin Onebyte(HZ); OZ:='JMP   @A+DPTR'; end;
       116: begin Twobyte(HZ); OZ:='MOV   A,'+Reg; end;
       117: begin Threbyte(HZ);
              OZ:='MOV   '+Reg+',#'+HEX(Puffer[PC1-1])+SFR8(2); end;
       128: begin Twobyte(HZ); OZ:='JR    '+RelAdr; end;
       130: begin Twobyte(HZ); OZ:='ANL   C,'+Reg+SFR1(1); end;
       131: begin Onebyte(HZ); OZ:='MOVC  A,@A+PC'; end;
       132: begin Onebyte(HZ); OZ:='DIV   AB'; end;
       133: begin Threbyte(HZ);
              OZ:='MOV   '+HEX(Puffer[PC1-1])+','+Reg+SFR8(1)+SFR8(2); end;
       144: begin Threbyte(HZ);
              OZ:='MOV   DPTR,#'+Reg+HEX(Puffer[PC1-1]); end;
       146: begin Twobyte(HZ); OZ:='MOV   '+Reg+',C'+SFR1(1); end;
       147: begin Onebyte(HZ); OZ:='MOVC  A,@A+DPTR'; end;
       148: begin Twobyte(HZ); OZ:='SUBB  A,'+Reg; end;
       149: begin Twobyte(HZ); OZ:='SUBB  A,'+Reg+SFR8(1); end;
       160: begin Twobyte(HZ); OZ:='ORL   C,/'+Reg+SFR1(1); end;
       162: begin Twobyte(HZ); OZ:='MOV   C,'+Reg+SFR1(1); end;
       163: begin Onebyte(HZ); OZ:='INC   DPTR'; end;
       164: begin Onebyte(HZ); OZ:='MUL   AB'; end;
       165: begin Onebyte(HZ); OZ:='---'; end;
       176: begin Twobyte(HZ); OZ:='ANL   C,/'+Reg+SFR1(1); end;
       178: begin Twobyte(HZ); OZ:='CPL   '+Reg+SFR1(1); end;
       179: begin Onebyte(HZ); OZ:='CPL   C'; end;
       180: begin Threbyte(HZ);
              OZ:='CJNE  A,'+Reg+','+RelAdr; end;
       181: begin Threbyte(HZ);
              OZ:='CJNE  A,'+Reg+','+RelAdr+SFR8(2); end;
       192: begin Twobyte(HZ); OZ:='PUSH  '+Reg+SFR8(1); end;
       194: begin Twobyte(HZ); OZ:='CLR   '+Reg+SFR1(1); end;
       195: begin Onebyte(HZ); OZ:='CLR   C'; end;
       196: begin Onebyte(HZ); OZ:='SWAP  A'; end;
       197: begin Twobyte(HZ); OZ:='XCH   A,'+Reg+SFR8(1); end;
       208: begin Twobyte(HZ); OZ:='POP   '+Reg+SFR8(1); end;
       210: begin Twobyte(HZ); OZ:='SETB  '+Reg+SFR1(1); end;
       211: begin Onebyte(HZ); OZ:='SETB  C'; end;
       212: begin Onebyte(HZ); OZ:='DA    A'; end;
       213: begin Threbyte(HZ);
              OZ:='DJNZ  '+Reg+','+RelAdr+SFR8(2); end;
       214: begin Onebyte(HZ); OZ:='XCHD  A,@R0'; end;
       215: begin Onebyte(HZ); OZ:='XCHD  A,@R1'; end;
       224: begin Onebyte(HZ); OZ:='MOVX  A,@DPTR'; end;
       226: begin Onebyte(HZ); OZ:='MOVX  A,@R0'; end;
       227: begin Onebyte(HZ); OZ:='MOVX  A,@R1'; end;
       228: begin Onebyte(HZ); OZ:='CLR   A'; end;
       229: begin Twobyte(HZ); OZ:='MOV   A,'+Reg+SFR8(1); end;
       240: begin Onebyte(HZ); OZ:='MOVX  @DPTR,A'; end;
       242: begin Onebyte(HZ); OZ:='MOVX  @R0,A'; end;
       243: begin Onebyte(HZ); OZ:='MOVX  @R1,A'; end;
       244: begin Onebyte(HZ); OZ:='CPL   A'; end;
       245: begin Twobyte(HZ); OZ:='MOV   '+Reg+',A'+SFR8(1); end;

        else begin
          if (OP mod 32)=1 then begin
            Twobyte(HZ); OZ:='AJMP  '+SprAdr(OP-1); end
          else if (OP mod 32)=17 then begin
            Twobyte(HZ); OZ:='ACALL '+SprAdr(OP-17); end
          else begin
          OP:=(OP and 240) div 16;
          case OP of
            0: begin Onebyte(HZ); OZ:='INC   '+Reg end;
            1: begin Onebyte(HZ); OZ:='DEC   '+Reg end;
            2: begin Onebyte(HZ); OZ:='ADD   A,'+Reg end;
            3: begin Onebyte(HZ); OZ:='ADDC  A,'+Reg end;
            4: begin Onebyte(HZ); OZ:='ORL   A,'+Reg end;
            5: begin Onebyte(HZ); OZ:='ANL   A,'+Reg end;
            6: begin Onebyte(HZ); OZ:='XRL   A,'+Reg end;
            7: begin Twobyte(HZ);
                 OZ:='MOV   '+Reg+',#'+HEX(Puffer[PC1-1]); end;
            8: begin Twobyte(HZ);
                 OZ:='MOV   '+HEX(Puffer[PC1-1])+','+Reg+SFR8(1); end;
            9: begin Onebyte(HZ); OZ:='SUBB  A,'+Reg end;
           10: begin Twobyte(HZ);
                 OZ:='MOV   '+Reg+','+HEX(Puffer[PC1-1])+SFR8(1); end;
           11: begin Threbyte(HZ);
                 OZ:='CJNE  '+Reg+',#'+HEX(Puffer[PC1-2])+','+RelAdr;
               end;
           12: begin Onebyte(HZ); OZ:='XCH   A,'+Reg; end;
           13: begin Twobyte(HZ);
                 OZ:='DJNZ  '+Reg+','+RelAdr; end;
           14: begin Onebyte(HZ); OZ:='MOV   A,'+Reg; end;
           15: begin Onebyte(HZ); OZ:='MOV   '+Reg+',A'; end;
           end;
           end;
          end;
        end;
        y:=WhereY;
        write(HZ,'    ',OZ);
        GotoXY(60,y);
        writeln(ASCII);
        ASCII1:=ASCII1+ASCII;
  end;

procedure DisPrint;

const leer = '                              ';
var zeilen,a : integer;
    enda   : string[10];
    endadr : integer;
begin
  repeat
    write('Endadresse: ');readln (enda);
    val('$'+enda,endadr,error);
  until (error=0) or (enda='');
  zeilen:=0;
  if enda='' then begin endadr:=0; zeilen:=1; end;
     repeat
      if zeilen=0 then begin
        writeln(LST,'Listing of ',fname);
        writeln(LST);writeln(LST);writeln(LST);
      end;
        write(LST,HEX2(PC1+PC0));
        diszeile;
        write(LST,'    ',HZ,'    ');
        a:=length(OZ);
        OZ:=OZ+Copy(leer,1,30-a);
        writeln(LST,OZ,ASCII);
        zeilen:=succ(zeilen);
      if zeilen=51 then begin
        for zeilen:=1 to 17 do writeln(LST);
        zeilen:=0;
      end;
    until (PC1+PC0)>=endadr;
end;

  begin
   if p=true then disprint else begin
    I:=0; maxI:=0; Adresse[I]:=PC1; ausg:=true;
    repeat
     if ausg=true then begin
      S:=0; ASCII1:=''; ClrScr;
      repeat
        DisZeile;
        s:=succ(s);
      until s=21;
      writeln;
      writeln('ASCII-Text:');
      writeln(ASCII1);
     end;
     ausg:=true;
     read(kbd,Taste);
     if Taste=#27 then begin read(kbd,Taste);
       case Taste of
 {PgUp} #73: if I>0 then begin I:=I-1; PC1:=Adresse[I]; end
             else ausg:=false;
 {PgDn} #81: if PC1>PC then ausg:=false else begin
             I:=succ(I);
             if I>maxI then begin maxI:=I; Adresse[I]:=PC1; end; end;
 {Home} #71: if I>0 then begin I:=0; PC1:=Adresse[0] end
             else ausg:=false;
 {End}  #79: if I<>maxI then begin I:=maxI; PC1:=Adresse[maxI] end
             else ausg:=false;
       else ausg:=false
      end; end else ausg:=false;
    until Taste=#13;
   end;
  end;
